## -*- coding: utf-8 -*-
## Copyright (C) 2007 Ingeniweb

## This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation; either version 2 of the License, or
## (at your option) any later version.

## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.

## You should have received a copy of the GNU General Public License
## along with this program; see the file COPYING. If not, write to the
## Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

from zope.app.traversing.interfaces import ITraversable
from Products.Five.traversable import FiveTraversable

from Products.ATContentTypes.interface.folder import IATFolder
from zope.component import adapts
from zope.interface import implements
#Imports for delete
from OFS.ObjectManager import ObjectManager
_getOb = ObjectManager._getOb
_delOb = ObjectManager._delOb
_marker = []

#Patch I18NBaseObject
from AccessControl import ClassSecurityInfo
from Products.LinguaPlone import permissions
from Products.LinguaPlone.I18NBaseObject import I18NBaseObject
from Products.CMFCore.utils import getToolByName

security = ClassSecurityInfo()

security.declareProtected(permissions.View, 'getCanonicalPath')
def getCanonicalPath(self):
    """ Return a path going only through canonical folders.  """
    if hasattr(self.aq_inner.aq_parent.aq_base, 'getCanonicalPath'):
        path = self.aq_inner.aq_parent.getCanonicalPath()
        path += (self.getCanonical().id,)
        return path
    else:
        return self.getCanonical().getPhysicalPath()

security.declareProtected(permissions.AccessContentsInformation, 'myGetTranslations')
def myGetTranslations(self):
    """ Return a table containting all the translations
    """
    languages = self.getTranslationLanguages()
    return [self.getTranslation(language) for language in languages]

security.declareProtected(permissions.AccessContentsInformation, 'getOtherTranslations')
def getOtherTranslations(self):
    """ Return a table containting all the translations
    """
    languages = self.getTranslationLanguages()
    languages.remove(self.getLanguage())
    return [self.getTranslation(language) for language in languages]

I18NBaseObject.getCanonicalPath = getCanonicalPath
I18NBaseObject.myGetTranslations = myGetTranslations
I18NBaseObject.getOtherTranslations = getOtherTranslations

class LinguaTraversable(FiveTraversable):
    """
    Modify traverse of translatable objects
    """
    adapts(IATFolder)
    implements(ITraversable)

    def traverse(self, name, furtherPath):
        """
        Modify the behavior of folder_delete, object_delete, folder_copy
        and folder_cut
        """
        if name == "folder_delete":
            return getattr(self._subject, "lingua_folder_delete")

        if name == "object_delete":
            return getattr(self._subject, "lingua_object_delete")

        if name == "folder_copy":
            return getattr(self._subject, "lingua_folder_copy")

        if name == "folder_cut":
            return getattr(self._subject, "lingua_folder_cut")

        if name == "folder_cut":
            return getattr(self._subject, "lingua_folder_cut")

        linguaface_tool = getToolByName(self._subject, 'linguaface_tool')
        if name == "content_status_modify" and linguaface_tool.getProperty('synchronise_translations_workflow'):
            return getattr(self._subject, "lingua_content_status_modify")

        return super(LinguaTraversable, self).traverse(name, furtherPath)
